#ifndef _H_SPI_
#define _H_SPI_

#define SPI_CPOL_0	(1 << 0)
#define SPI_CPOL_1	0
#define SPI_NCPHA_0	(1 << 1)
#define SPI_NCPHA_1	0

#define SPI_MODE_0	(SPI_CPOL_0 | SPI_NCPHA_1)
#define SPI_MODE_1	(SPI_CPOL_0 | SPI_NCPHA_0)
#define SPI_MODE_2	(SPI_CPOL_1 | SPI_NCPHA_1)
#define SPI_MODE_3	(SPI_CPOL_1 | SPI_NCPHA_0)

struct spi_tblk {
	void *rx;
	const void *tx;
	int len;
};

void spi_init();
void spi_mode(int cs, int pol, int bits, int baud, int dely);
void spi_select(int cs);
void spi_transfer(struct spi_tblk *blk, int n);

#endif /* _H_SPI_ */

