#include <stdint.h>

#include <sdram.h>
#include <AT91RM9200.h>
#include <config.h>
#include <serial.h>
#include <utils.h>

#define SDRAM		"SDRAM: "

void sdram_init()
{
	uint32_t tmp32;
	int i;

	volatile int *sdram = (int*) SDRAM_BASE_ADDRESS;

	tmp32 = (	AT91C_PC16_D16 |
			AT91C_PC17_D17 |
			AT91C_PC18_D18 |
			AT91C_PC19_D19 |
			AT91C_PC20_D20 |
			AT91C_PC21_D21 |
			AT91C_PC22_D22 |
			AT91C_PC23_D23 |
			AT91C_PC24_D24 |
			AT91C_PC25_D25 |
			AT91C_PC26_D26 |
			AT91C_PC27_D27 |
			AT91C_PC28_D28 |
			AT91C_PC29_D29 |
			AT91C_PC30_D30 |
			AT91C_PC31_D31 );

	AT91C_BASE_PIOC->PIO_ASR = tmp32;
	AT91C_BASE_PIOC->PIO_PDR = tmp32;

	AT91C_BASE_EBI->EBI_CSA |= AT91C_EBI_CS1A;
	AT91C_BASE_EBI->EBI_CFGR = (AT91C_EBI_DBPUC & 0x00);

	AT91C_BASE_SDRC->SDRC_CR =
		AT91C_SDRC_NC_9 |
		AT91C_SDRC_NR_13 |
		AT91C_SDRC_NB_4_BANKS |
		AT91C_SDRC_CAS_2 |
		0x100 | 0x4000 | 0x8000 |
		0x880000 | 0x21000000;

	nops(1);

	AT91C_BASE_SDRC->SDRC_MR = AT91C_SDRC_MODE_PRCGALL_CMD;
	*sdram = 0x0;

	AT91C_BASE_SDRC->SDRC_MR = AT91C_SDRC_MODE_RFSH_CMD;
	for (i = 0; i < 8; ++i)
		*sdram = 0x0;

	AT91C_BASE_SDRC->SDRC_MR = AT91C_SDRC_MODE_LMR_CMD;
	*(sdram + 0x80) = 0x0;

	AT91C_BASE_SDRC->SDRC_TR = (AT91C_SDRC_COUNT & 0xfff);
	*sdram = 0x0;

	AT91C_BASE_SDRC->SDRC_MR = AT91C_SDRC_MODE_NORMAL_CMD;
	*sdram = 0x0;
}

void sdram_info()
{
	serial_printk(SDRAM "%i MB %i-bit\n", (SDRAM_SIZE >> 20), 32);
	serial_printk(SDRAM "SDRC_CR: %x\n", AT91C_BASE_SDRC->SDRC_CR);
}

