#include <stdint.h>

#include <utils.h>
#include <config.h>

uint32_t rval;

void nops(int tv)
{
	volatile int vv;
	int i, j;

	for (j = 0; j < tv; ++j) {
		for (i = 0; i < 32; ++i) {
			vv = (i);
		}
	}
}

uint32_t rand32()
{
	return (rval = 13723 * rval + 1);
}

uint32_t randpw()
{
	uint32_t val = 0;
	int i;

	for (i = 0; i < 32; ++i)
		val |= (rand32() & (1<<31)) ? (1<<i) : 0;

	return val;
}

/* FIXME: This function work with ord-aligned data only
 * */
void memcopy(void *dst, const void *src, int len)
{
	const uint32_t *ptr_r = src;
	const uint32_t *ptr_fin = ptr_r + (len >> 2);
	uint32_t *ptr_w = dst;

	while (ptr_r != ptr_fin) {
		*ptr_w++ = *ptr_r++;
	}

	len &= 0x03;

	const uint8_t *ptr8_r = (uint8_t*) ptr_r;
	const uint8_t *ptr8_fin = ptr8_r + len;
	uint8_t *ptr8_w = (uint8_t*) ptr_w;

	while (ptr8_r != ptr8_fin) {
		*ptr8_w++ = *ptr8_r++;
	}
}

/* FIXME: Incorrect operation when values too large
 * */
void __u32divmod(uint32_t num, uint32_t den,
		uint32_t *result, uint32_t *rem)
{
	uint32_t ret = 0;
	uint32_t sub_val, sub_val_s;
	int bit, bit_s;
	int done;

	if (den == 0)
		return;

	do {
		sub_val = sub_val_s = den;
		bit = bit_s = 0;
		done = 1;

		do {
			if (sub_val_s > num)
				break;
			else {
				sub_val = sub_val_s;
				bit = bit_s;
			}

			sub_val_s <<= 1;
			++bit_s;

			done = 0;

		} while (1);

		if (done)
			break;
		else {
			ret |= (1 << bit);
			num -= sub_val;
		}

	} while (1);

	if (result) {
		*result = ret;
	}

	if (rem) {
		*rem = num;
	}
}

uint16_t crc16(uint8_t *ptr, int len)
{
	uint16_t crc, i;
	crc = 0x0000;

	while (len--) {
		crc ^= (uint16_t) *ptr++ << 8;
		for (i = 0; i < 8; ++i)
			crc = (crc & 0x8000) ? (crc << 1) ^ 0x1021 : crc << 1;
	}

	return crc;
}

uint32_t swab32(uint32_t val)
{
	return (((0x000000ff & val) << 24) |
		((0x0000ff00 & val) << 8) |
		((0x00ff0000 & val) >> 8) |
		((0xff000000 & val) >> 24));
}

#define IS_DCHAR(c)		((0x30 <= (c)) && (0x3a > (c)))
#define CHAR_TO_INT(c)		((c) - 0x30)

uint32_t strtou32(const char *str)
{
	uint32_t ret = 0;

	while ((*str) && IS_DCHAR(*str)) {
		ret = ret * 10 + CHAR_TO_INT(*str);
		++str;
	}

	return ret;
}

int strequ(const char *str1, const char *str2)
{
	while ((*str1) && (*str2) &&
			(*str1 == *str2)) {
		++str1;
		++str2;
	}

	if (!(*str1) && !(*str2))
		return 1;
	else
		return 0;
}

void strcopy(char *dst, const char *src)
{
	while (*src) {
		*dst++ = *src++;
	}
}

