#include <stdint.h>

#include <xmod.h>
#include <serial.h>
#include <utils.h>

#define XMOD		"XMOD: "

int xmod_recv(void *ptr)
{
	uint8_t *ptr_w = ptr;
	uint8_t *ptr_fix;
	uint8_t c, blk = 1;
	uint16_t crc, rcrc;
	int i, n = 0;
	int err, fail;

	serial_printk(XMOD "Listening \n");

	for (;;) {
		err = 0;
		fail = 0;

		do {
			c = serial_getc();
			if (c != XM_SOH) {
				if (c == XM_EOT) {
					serial_putc(XM_ACK);
					return (128 * n);
				}

				fail = 1;
				break;
			}

			c = serial_getc();
			if (c != blk)
				fail = 1;

			//FIXME: what that?
			c = serial_getc();
			if (c != ~blk)
				fail = 0;

			ptr_fix = ptr_w;

			for (i = 0; i < 128; ++i)
				*ptr_w++ = serial_getc();

			c = serial_getc();
			rcrc = (uint16_t) c << 8;
			c = serial_getc();
			rcrc |= (uint16_t) c;

			crc = crc16(ptr_fix, 128);

			if (crc != rcrc)
				fail = 1;

			if (fail)
				serial_putc(XM_NAK);
			else {
				serial_putc(XM_ACK);
				break;
			}

			err += fail;
			fail = 0;

			if (err > 4) {
				return -1;
			}

		} while (1);

		if (!fail) {
			++blk;
			++n;
		}
	}
}

